/****** Object:  StoredProcedure [dbo].[X_OT_SVC_REVREC_MARK_UNMARK_ALL]    Script Date: 12/01/2010 14:36:24 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[X_OT_SVC_REVREC_MARK_UNMARK_ALL]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[X_OT_SVC_REVREC_MARK_UNMARK_ALL]
GO

/****** Object:  StoredProcedure [dbo].[X_OT_SVC_REVREC_MARK_UNMARK_ALL]    Script Date: 12/01/2010 14:36:24 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


create procedure [dbo].[X_OT_SVC_REVREC_MARK_UNMARK_ALL] (@FLAG tinyint, @USERID CHAR(15), @OTHERUSERS tinyint OUTPUT)

as

/*
AUTHOR: AARON BERQUIST
WWW.AARONBERQUIST.COM
AARON@AARONBERQUIST.COM

DATE: 09/14/2010

PURPOSE: THIS PROCEDURE REPLACES THE OUT-OF-THE-BOX METHOD FOR MARKING ALL CONTRACTS TO POST
IN THE REVENUE RECOGNITION WINDOW.

IT REPLACES THE PROCEDURE SVC_Check_Contract_Revenue WHICH WAS CALLED BY THE ORIGINAL "MARK ALL" BUTTON

NAVIGATION: TRANSACTIONS: CONTRACT ADMINISTRATION: REVENUE RECOGNITION: MARK ALL or UNMARK ALL BUTTON
*/

--CHECK TO SEE IF ANOTHER USER HAS CONTRACTS MARKED TO POST
--WHICH WE HAVE LOADED INTO OUR WINDOW

--IF SO, MARK ALL OF THE CONTRACTS TO POST EXCEPT FOR THOSE MARKED BY ANOTHER USER
--AND SET THE @OTHERUSERS FLAG = 1
--THIS WILL TRIGGER A MESSAGE IN THE VB ROUTINE TO ALERT THE USER TO THIS SITUATION

IF @FLAG = 0
--UNMARK ALL
BEGIN
	UPDATE SVC00625 SET MKDTOPST = 0 WHERE USERID = @USERID
END
ELSE
--MARK ALL
BEGIN

	CREATE TABLE #T1 (
	CONSTS tinyint,
	CONTNBR char(11),
	YEAR1 int,
	PERIODID tinyint
	)

	INSERT #T1 SELECT us.consts, us.contnbr, us.year1, us.periodid FROM SVC00625 us
				INNER JOIN SVC00625 other on us.consts = other.consts
					and us.contnbr = other.contnbr
					and us.year1 = other.year1
					and us.periodid = other.periodid
					and us.USERID = @USERID
				where us.userid <> other.userid and other.mkdtopst = 1
			
	IF @@ROWCOUNT <> 0
	BEGIN			
		SELECT @OTHERUSERS = 1
	END
	ELSE
	BEGIN
		SELECT @OTHERUSERS = 0
	END

/*
	UPDATE SVC00625 SET MKDTOPST = 1 WHERE USERID = @USERID AND CONTNBR NOT IN (
		SELECT CONTNBR FROM #T1)
*/

	UPDATE SVC00625 SET MKDTOPST = 1 FROM SVC00625 a
		LEFT JOIN #T1 t on t.consts = a.consts and t.contnbr = a.contnbr and t.year1 = a.year1 and t.periodid = a.periodid
		where t.contnbr is null and USERID = @USERID
END




GO

GRANT EXECUTE ON [dbo].[X_OT_SVC_REVREC_MARK_UNMARK_ALL] TO [DYNGRP] AS [dbo]
GO


